<?php
if(!defined('IN_MYBB')) die();
$lang->load('mn_fprom');
$page->add_breadcrumb_item($lang->mn_fprom,mn_fprom_url());
if(!$groupscache) $groupscache = $cache->read('usergroups');
if(!$forum_cache) $forum_cache = cache_forums();
$sub_tabs['mn_fprom'] = array(
	'title' => $lang->mn_fprom,
	'link' => mn_fprom_url(),
	'description' => $lang->mn_fprom_desc
);
$sub_tabs['mn_fprom_add'] = array(
	'title' => $lang->mn_fprom_add,
	'link' => mn_fprom_url('add'),
	'description' => $lang->mn_fprom_add_desc
);
$sub_tabs['mn_fprom_logs'] = array(
	'title' => $lang->mn_fprom_view_logs,
	'link' => mn_fprom_url('logs'),
	'description' => $lang->mn_fprom_view_logs_desc
);
$plugins->run_hooks('admin_forum_mn_fprom_begin');
if($mybb->input['action'] == 'disable'){
	$plugins->run_hooks('admin_forum_mn_fprom_disable');
	if($mybb->input['no']) admin_redirect(mn_fprom_url()); 
	if(!trim($mybb->input['promid'])){
		flash_message($lang->mn_fprom_error_no_promid,'error');
		admin_redirect(mn_fprom_url());
	}
	$query = $db->simple_select('mn_fprom','*','promid='.intval($mybb->input['promid']));
	$promotion = $db->fetch_array($query);
	if(!$promotion['promid']){
		flash_message($lang->mn_fprom_error_invalid_promid,'error');
		admin_redirect(mn_fprom_url());
	}
	if($mybb->request_method == 'post'){
		$promotion = array('promactive' => 0);
		$db->update_query('mn_fprom',$promotion,'promid='.intval($mybb->input['promid']));
		$plugins->run_hooks('admin_forum_mn_fprom_disable_commit');
		log_admin_action($promotion['promid'],$promotion['promtitle']);
		flash_message($lang->mn_fprom_success_promo_disabled,'success');
		admin_redirect(mn_fprom_url());
	}else{
		$page->output_confirm_action(mn_fprom_url('disable',$promotion,'promid'),$lang->mn_fprom_confirm_promo_disable); 
	}
}

if($mybb->input['action'] == 'delete'){
	$plugins->run_hooks('admin_forum_mn_fprom_delete');
	if($mybb->input['no']) admin_redirect(mn_fprom_url()); 
	if(!trim($mybb->input['promid'])){
		flash_message($lang->mn_fprom_error_no_promid,'error');
		admin_redirect(mn_fprom_url());
	}
	$query = $db->simple_select('mn_fprom','*','promid='.intval($mybb->input['promid']));
	$promotion = $db->fetch_array($query);
	if(!$promotion['promid']){
		flash_message($lang->mn_fprom_error_invalid_promid,'error');
		admin_redirect(mn_fprom_url());
	}
	if($mybb->request_method == 'post'){
		$db->delete_query('mn_fprom','promid='.intval($mybb->input['promid']));
		$plugins->run_hooks('admin_forum_mn_fprom_delete_commit');
		log_admin_action($promotion['promid'],$promotion['promtitle']);
		flash_message($lang->mn_fprom_success_promo_deleted,'success');
		admin_redirect(mn_fprom_url());
	}else{
		$page->output_confirm_action(mn_fprom_url('delete',$mybb->input,'promid'),$lang->mn_fprom_confirm_promdel); 
	}
}

if($mybb->input['action'] == 'enable'){
	$plugins->run_hooks('admin_forum_mn_fprom_enable');
	if(!verify_post_check($mybb->input['my_post_key'])){
		flash_message($lang->invalid_post_verify_key2,'error');
		admin_redirect(mn_fprom_url());
	}
	if(!trim($mybb->input['promid'])){
		flash_message($lang->error_no_promo_id,'error');
		admin_redirect(mn_fprom_url());
	}
	$query = $db->simple_select('mn_fprom','*','promid='.intval($mybb->input['promid']));
	$promotion = $db->fetch_array($query);
	if(!$promotion['promid']){
		flash_message($lang->mn_fprom_error_invalid_promid,'error');
		admin_redirect(mn_fprom_url());
	}
	$promotion = array('promactive' => 1);
	$db->update_query('mn_fprom',$promotion,'promid='.intval($mybb->input['promid']));
	$plugins->run_hooks('admin_forum_mn_fprom_enable_commit');
	log_admin_action($promotion['promid'],$promotion['promtitle']);
	flash_message($lang->mn_fprom_success_promo_enabled,'success');
	admin_redirect(mn_fprom_url());
}

if($mybb->input['action'] == 'edit'){
	$plugins->run_hooks('admin_forum_mn_fprom_edit');
	if(!trim($mybb->input['promid'])){
		flash_message($lang->mn_fprom_error_no_promid,'error');
		admin_redirect(mn_fprom_url());
	}
	$query = $db->simple_select('mn_fprom','*','promid='.intval($mybb->input['promid']));
	$promotion = $db->fetch_array($query);
	if(!$promotion){
		flash_message($lang->mn_fprom_error_no_promid,'error');
		admin_redirect(mn_fprom_url());
	}
	if($mybb->request_method == 'post'){
		if(!trim($mybb->input['promtitle'])) $errors[] = $lang->sprintf($lang->mn_fprom_error_no_title,$lang->mn_fprom_title);
		if(intval($mybb->input['promdo']) < 1) $errors[] = $lang->sprintf($lang->mn_fprom_error_no_do,$lang->mn_fprom_do);
		if(!$mybb->input['promreq']) $errors[] = $lang->sprintf($lang->mn_fprom_error_no_req,$lang->mn_fprom_req);
		if(!$mybb->input['promcounttype']) $errors[] = $lang->sprintf($lang->mn_fprom_error_no_ct,$lang->mn_fprom_req);
		if(intval($mybb->input['promcount']) < 1) $errors[] = $lang->sprintf($lang->mn_fprom_error_no_count,$lang->mn_fprom_req);
		if(empty($mybb->input['promforum'])) $errors[] = $lang->mn_fprom_error_no_forum;
		if(!$mybb->input['promoug']) $errors[] = $lang->mn_fprom_error_no_oug;
		if(!$mybb->input['promnug']) $errors[] = $lang->mn_fprom_error_no_nug;
		if(!$mybb->input['promugtype']) $errors[] = $lang->mn_fprom_error_no_ugtype;
		if($mybb->input['promoug'] == $mybb->input['promnug']) $errors[] = $lang->sprintf($lang->mn_fprom_error_same_ug,$lang->mn_fprom_ug);
		if(!$errors){			
			$update_promotion = array(
				'promtitle' => $db->escape_string($mybb->input['promtitle']),
				'promdo' => intval($mybb->input['promdo']),
				'promreq' => intval($mybb->input['promreq']),
				'promcounttype' => $db->escape_string($mybb->input['promcounttype']),
				'promcount' => intval($mybb->input['promcount']),
				'promforum' => $db->escape_string(implode(',',array_map('intval',$mybb->input['promforum']))),
				'promoug' => intval($mybb->input['promoug']),
				'promnug' => intval($mybb->input['promnug']),
				'promugtype' => intval($mybb->input['promugtype']),
				'promactive' => intval($mybb->input['promactive'])
			);
			$db->update_query('mn_fprom',$update_promotion,'promid='.intval($mybb->input['promid']));
			$plugins->run_hooks('admin_forum_mn_fprom_edit_commit');
			log_admin_action($promotion['promid'],$mybb->input['promtitle']);
			flash_message($lang->mn_fprom_success_promo_updated,'success');
			admin_redirect(mn_fprom_url());
		}
	}
	$page->add_breadcrumb_item($lang->mn_fprom_edit);
	$page->output_header($lang->mn_fprom.' - '.$lang->mn_fprom_edit);
	$sub_tabs = array();
	$sub_tabs['mn_fprom_edit'] = array(
		'title' => $lang->mn_fprom_edit,
		'link' => mn_fprom_url('edit',$promotion,'promid'),
		'description' => $lang->mn_fprom_edit_desc
	);
	$page->output_nav_tabs($sub_tabs,'mn_fprom_edit');
	$form = new Form(mn_fprom_url('edit',$promotion,'promid'),'post','edit');
	echo $form->generate_hidden_field('promid', $mybb->input['promid']);
	if($errors){
		$page->output_inline_error($errors);
	}else{
		$mybb->input['promtitle'] = $promotion['promtitle'];
		$mybb->input['promdo'] = $promotion['promdo'];
		$mybb->input['promreq'] = $promotion['promreq'];
		$mybb->input['promcounttype'] = $promotion['promcounttype'];
		$mybb->input['promcount'] = $promotion['promcount'];
		$mybb->input['promforum'] = explode(',',$promotion['promforum']);
		$mybb->input['promoug'] = $promotion['promoug'];
		$mybb->input['promnug'] = $promotion['promnug'];
		$mybb->input['promugtype'] = $promotion['promugtype'];
		$mybb->input['promactive'] = $promotion['promactive'];
	}
	$form_container = new FormContainer($lang->mn_fprom_edit);
	$form_container->output_row($lang->mn_fprom_title_do.' <em>*</em>',$lang->mn_fprom_title_do_desc,$form->generate_text_box('promdo',$mybb->input['promdo'],array('id'=>'promdo','class'=>'field50')).' '.$form->generate_text_box('promtitle',$mybb->input['promtitle'],array('id'=>'promtitle')),'promtitle');
	$promreq = array(
		1 => $lang->mn_fprom_post_count,
		2 => $lang->mn_fprom_thread_count
	);
	$promcounttype = array(
		'>' => $lang->mn_fprom_greater_than,
		'>=' => $lang->mn_fprom_greater_than_or_equal_to,
		'=' => $lang->mn_fprom_equal_to,
		'<=' => $lang->mn_fprom_less_than_or_equal_to,
		'<' => $lang->mn_fprom_less_than
	);
	$promugtype = array(
		1 => $lang->mn_fprom_pug,
		2 => $lang->mn_fprom_sug,
		3 => $lang->mn_fprom_rsug
	);
	$options = array();
	$query = $db->simple_select('usergroups','gid,title','gid!=1',array('order_by'=>'title'));
	while($usergroup = $db->fetch_array($query)){
		$options[(int)$usergroup['gid']] = $usergroup['title'];
	}
	$lang->mn_fprom_ug_desc = $lang->sprintf($lang->mn_fprom_ug_desc,$lang->mn_fprom_pug,$lang->mn_fprom_sug);
	$form_container->output_row($lang->mn_fprom_req.'<em>*</em>',$lang->mn_fprom_req_desc,$form->generate_select_box('promreq',$promreq,$mybb->input['promreq'],array('id'=>'promreq')).' '.$form->generate_select_box('promcounttype',$promcounttype,$mybb->input['promcounttype'],array('id'=>'promcounttype')).' '.$form->generate_text_box('promcount',$mybb->input['promcount'],array('id'=>'promcount','class'=>'field50')),'promcount');
	$form_container->output_row($lang->mn_fprom_forum.' <em>*</em>',$lang->mn_fprom_forum_desc,$form->generate_forum_select('promforum[]',$mybb->input['promforum'],array('multiple'=>true,'size'=>5)));
	$form_container->output_row($lang->mn_fprom_ug.' <em>*</em>',$lang->mn_fprom_ug_desc,$form->generate_select_box('promoug',$options,$mybb->input['promoug'],array('id'=>'promoug')).' '.$form->generate_select_box('promugtype',$promugtype,$mybb->input['promugtype'],array('id'=>'promugtype')).' '.$form->generate_select_box('promnug',$options,$mybb->input['promnug'],array('id'=>'promnug')),'promugtype');
	$form_container->output_row($lang->mn_fprom_enabled.' <em>*</em>',$lang->mn_fprom_enabled_desc,$form->generate_yes_no_radio('promactive',$mybb->input['promactive'],true));
	$form_container->end();
	$buttons[] = $form->generate_submit_button($lang->mn_fprom_update_promotion);
	$form->output_submit_wrapper($buttons);
	$form->end();
	$page->output_footer();
}

if($mybb->input['action'] == 'add'){
	$plugins->run_hooks('admin_forum_mn_fprom_add');
	if($mybb->request_method == 'post'){
		if(!trim($mybb->input['promtitle'])) $errors[] = $lang->sprintf($lang->mn_fprom_error_no_title,$lang->mn_fprom_title);
		if(intval($mybb->input['promdo']) < 1) $errors[] = $lang->sprintf($lang->mn_fprom_error_no_do,$lang->mn_fprom_do);
		if(!$mybb->input['promreq']) $errors[] = $lang->sprintf($lang->mn_fprom_error_no_req,$lang->mn_fprom_req);
		if(!$mybb->input['promcounttype']) $errors[] = $lang->sprintf($lang->mn_fprom_error_no_ct,$lang->mn_fprom_req);
		if(intval($mybb->input['promcount']) < 1) $errors[] = $lang->sprintf($lang->mn_fprom_error_no_count,$lang->mn_fprom_req);
		if(empty($mybb->input['promforum'])) $errors[] = $lang->mn_fprom_error_no_forum;
		if(!$mybb->input['promoug']) $errors[] = $lang->mn_fprom_error_no_oug;
		if(!$mybb->input['promnug']) $errors[] = $lang->mn_fprom_error_no_nug;
		if(!$mybb->input['promugtype']) $errors[] = $lang->mn_fprom_error_no_ugtype;
		if($mybb->input['promoug'] == $mybb->input['promnug']) $errors[] = $lang->sprintf($lang->mn_fprom_error_same_ug,$lang->mn_fprom_ug);
		if(!$errors){			
			$new_promotion = array(
				'promtitle' => $db->escape_string($mybb->input['promtitle']),
				'promdo' => intval($mybb->input['promdo']),
				'promreq' => intval($mybb->input['promreq']),
				'promcounttype' => $db->escape_string($mybb->input['promcounttype']),
				'promcount' => intval($mybb->input['promcount']),
				'promforum' => $db->escape_string(implode(',',array_map('intval',$mybb->input['promforum']))),
				'promoug' => intval($mybb->input['promoug']),
				'promnug' => intval($mybb->input['promnug']),
				'promugtype' => intval($mybb->input['promugtype']),
				'promactive' => intval($mybb->input['promactive'])
			);
			$pid = $db->insert_query('mn_fprom',$new_promotion);
			$plugins->run_hooks('admin_forum_mn_fprom_add_commit');
			log_admin_action($pid,$mybb->input['promtitle']);
			flash_message($lang->mn_fprom_success_promo_added,'success');
			admin_redirect(mn_fprom_url());
		}
	}
	$page->add_breadcrumb_item($lang->mn_fprom_add);
	$page->output_header($lang->mn_fprom.' - '.$lang->mn_fprom_add);
	$sub_tabs['mn_fprom'] = array(
		'title' => $lang->mn_fprom,
		'link' => mn_fprom_url()
	);
	$sub_tabs['mn_fprom_add'] = array(
		'title' => $lang->mn_fprom_add,
		'link' => mn_fprom_url('add'),
		'description' => $lang->mn_fprom_add_desc
	);
	$sub_tabs['mn_fprom_logs'] = array(
		'title' => $lang->mn_fprom_view_logs,
		'link' => mn_fprom_url('logs')
	);
	$page->output_nav_tabs($sub_tabs,'mn_fprom_add');
	$form = new Form(mn_fprom_url('add'),'post','add');
	if($errors){
		$page->output_inline_error($errors);
	}else{
		$mybb->input['promreq'] = 1;
		$mybb->input['promcounttype'] = '>';
		$mybb->input['promcount'] = '0';
		$mybb->input['promoug'] = 2;
		$mybb->input['promnug'] = 2;
		$mybb->input['promugtype'] = 1;
		$mybb->input['promactive'] = 1;
	}
	$form_container = new FormContainer($lang->mn_fprom_add);
	$form_container->output_row($lang->mn_fprom_title_do.' <em>*</em>',$lang->mn_fprom_title_do_desc,$form->generate_text_box('promdo',$mybb->input['promdo'],array('id'=>'promdo','class'=>'field50')).' '.$form->generate_text_box('promtitle',$mybb->input['promtitle'],array('id'=>'promtitle')),'promtitle');
	$promreq = array(
		1 => $lang->mn_fprom_post_count,
		2 => $lang->mn_fprom_thread_count
	);
	$promcounttype = array(
		'>' => $lang->mn_fprom_greater_than,
		'>=' => $lang->mn_fprom_greater_than_or_equal_to,
		'=' => $lang->mn_fprom_equal_to,
		'<=' => $lang->mn_fprom_less_than_or_equal_to,
		'<' => $lang->mn_fprom_less_than
	);
	$promugtype = array(
		1 => $lang->mn_fprom_pug,
		2 => $lang->mn_fprom_sug,
		3 => $lang->mn_fprom_rsug
	);
	$form_container->output_row($lang->mn_fprom_req.'<em>*</em>',$lang->mn_fprom_req_desc,$form->generate_select_box('promreq',$promreq,$mybb->input['promreq'],array('id'=>'promreq')).' '.$form->generate_select_box('promcounttype',$promcounttype,$mybb->input['promcounttype'],array('id'=>'promcounttype')).' '.$form->generate_text_box('promcount',$mybb->input['promcount'],array('id'=>'promcount','class'=>'field50')),'promcount');
	$form_container->output_row($lang->mn_fprom_forum.' <em>*</em>',$lang->mn_fprom_forum_desc,$form->generate_forum_select('promforum[]',$mybb->input['promforum'],array('multiple'=>true,'size'=>5)));
	$options = array();
	$query = $db->simple_select('usergroups','gid,title','gid!=1',array('order_by'=>'title'));
	while($usergroup = $db->fetch_array($query)){
		$options[(int)$usergroup['gid']] = $usergroup['title'];
	}
	$lang->mn_fprom_ug_desc = $lang->sprintf($lang->mn_fprom_ug_desc,$lang->mn_fprom_pug,$lang->mn_fprom_sug,$lang->mn_fprom_rsug);
	$form_container->output_row($lang->mn_fprom_ug.' <em>*</em>',$lang->mn_fprom_ug_desc,$form->generate_select_box('promoug',$options,$mybb->input['promoug'],array('id'=>'promoug')).' '.$form->generate_select_box('promugtype',$promugtype,$mybb->input['promugtype'],array('id'=>'promugtype')).' '.$form->generate_select_box('promnug',$options,$mybb->input['promnug'],array('id'=>'promnug')),'promugtype');
	$form_container->output_row($lang->mn_fprom_enabled.' <em>*</em>',$lang->mn_fprom_enabled_desc,$form->generate_yes_no_radio('promactive',$mybb->input['promactive'],true));
	$form_container->end();
	$buttons[] = $form->generate_submit_button($lang->mn_fprom_update_promotion);
	$form->output_submit_wrapper($buttons);
	$form->end();
	$page->output_footer();
}

if($mybb->input['action'] == 'logs'){
	$plugins->run_hooks('admin_forum_mn_fprom_logs');
	if($mybb->request_method == 'post' && $mybb->input['prune'] == 1){	
		if(!is_super_admin($mybb->user['uid'])){
			flash_message($lang->mn_fprom_logs_prune_error,'error');
			admin_redirect(mn_fprom_url('logs'));
		}
		$prune_del_time = TIME_NOW-(intval($mybb->input['day_range'])*86400);
		$del = $db->delete_query('mn_fprom_logs','dateline < '.$prune_del_time);
		$num_deleted = $db->affected_rows();
		log_admin_action($mybb->input['day_range'],$num_deleted);
		if($num_deleted){
			flash_message($lang->sprintf($lang->mn_fprom_success_logs_prune,my_number_format($num_deleted),strtolower($lang->mn_fprom_older_than),intval($mybb->input['day_range']),$lang->mn_fprom_days),'success');
		}else{
			flash_message($lang->sprintf($lang->mn_fprom_no_logs_prune,strtolower($lang->mn_fprom_older_than),intval($mybb->input['day_range']),$lang->mn_fprom_days),'error');
		}
		admin_redirect(mn_fprom_url('logs'));
	}
	if($mybb->input['page'] && $mybb->input['page'] > 1){
		$mybb->input['page'] = intval($mybb->input['page']);
		$start = ($mybb->input['page']*20)-20;
	}else{
		$mybb->input['page'] = 1;
		$start = 0;
	}
	$page->add_breadcrumb_item($lang->mn_fprom_view_logs);
	$page->output_header($lang->mn_fprom.' - '.$lang->mn_fprom_view_logs);
	$page->output_nav_tabs($sub_tabs,'mn_fprom_logs');
	$table = new Table;
	$total_rows = $db->fetch_field($db->simple_select('mn_fprom_logs','COUNT(promlid) as promotionlogs'),'promotionlogs');
	if($total_rows){
		$table->construct_header($lang->mn_fprom_promoted_user,array('class'=>'align_center','width'=>'20%'));
		$table->construct_header($lang->mn_fprom_promote_desc,array('class'=>'align_center','width'=>'60%'));
		$table->construct_header($lang->mn_fprom_dateline,array('class'=>'align_center','width'=>'20%'));
		$query = $db->query('
			SELECT pl.*,u.username
			FROM '.TABLE_PREFIX.'mn_fprom_logs pl
			LEFT JOIN '.TABLE_PREFIX.'users u ON (u.uid=pl.uid)
			ORDER BY promlid DESC 
			LIMIT '.$start.',20
		');
		while($log = $db->fetch_array($query)){
			$log['username'] = '<a href="index.php?module=user-view&amp;action=edit&amp;uid='.$log['uid'].'">'.htmlspecialchars_uni($log['username']).'</a><br />';
			$groupex = explode(',',$log['promoug']);
			if(is_array($groupex)){
				$log_promougs = $logcomma = '';
				foreach($groupex as $gid){
					if($gid){
						if($groupscache[$gid]['gid']){
							$log_promoug = format_name(htmlspecialchars_uni($groupscache[$gid]['title']),$groupscache[$gid]['gid'],$groupscache[$gid]['gid']);
						}else{
							$log_promoug = $lang->mn_fprom_deleted_ug;
						}
						$log_promougs .= $logcomma.$log_promoug;
						if(!$logcomma) $logcomma = ', ';
					}else{
						$log_promougs = $lang->mn_fprom_none;
					}
				}
			}
			if($groupscache[$log['promnug']]['gid']){
				$log['promnug'] = format_name(htmlspecialchars_uni($groupscache[$log['promnug']]['title']),$groupscache[$log['promnug']]['gid'],$groupscache[$log['promnug']]['gid']);
			}else{
				$log['promnug'] = $lang->mn_fprom_deleted_ug;
			}
			switch ($log['promugtype']){
				case 1: $log['promugtype'] = $lang->sprintf($lang->mn_fprom_change_pug,$log_promougs,$log['promnug']); break;
				case 2: $log['promugtype'] = $lang->sprintf($lang->mn_fprom_added_sug,$log['promnug'],$log_promougs); break;
				case 3: $log['promugtype'] = $lang->sprintf($lang->mn_fprom_removed_sug,$log['promnug'],$log_promougs); break;
			}
			$log['dateline'] = my_date($mybb->settings['dateformat'],$log['dateline']).', '.my_date($mybb->settings['timeformat'],$log['dateline']);
			$table->construct_cell($log['username'],array('class'=>'smalltext'));
			$table->construct_cell($log['promugtype'],array('class'=>'smalltext'));
			$table->construct_cell($log['dateline'],array('class'=>'smalltext'));
			$table->construct_row();
		}
	}
	if($table->num_rows() == 0){
		$table->construct_cell($lang->mn_fprom_no_promotion_logs);
		$table->construct_row();
	}
	$table->output($lang->mn_fprom_view_logs);
	echo '<br />'.draw_admin_pagination($mybb->input['page'],'20',$total_rows,mn_fprom_url('logs').'&amp;page='.page);
	if($total_rows){
		$form = new Form(mn_fprom_url('logs').'&amp;prune=1','post');
		$form_container = new FormContainer($lang->mn_fprom_logs_prune);
		if(!$mybb->input['day_range']) $mybb->input['day_range'] = 10;
		$form_container->output_row('','',$lang->mn_fprom_older_than.$form->generate_text_box('day_range',$mybb->input['day_range'],array('id'=>'day_range','style'=>'width: 30px')).' '.$lang->mn_fprom_days,'day_range');
		$form_container->end();
		$buttons[] = $form->generate_submit_button($lang->mn_fprom_logs_prune);
		$form->output_submit_wrapper($buttons);
		$form->end();
	}
	$page->output_footer();
}

if(!$mybb->input['action']){
	$page->output_header($lang->mn_fprom);
	$page->output_nav_tabs($sub_tabs,'mn_fprom');
	$form = new Form(mn_fprom_url('update'),'post','update');
	$table = new Table;
	$query = $db->simple_select('mn_fprom','*','',array('order_by'=>'promdo','order_dir'=>'asc'));
	if($db->num_rows($query)){
		$table->construct_header($lang->mn_fprom_promote_desc,array('colspan'=>2));
		$table->construct_header($lang->controls,array('class'=>'align_center','width'=>100));
		while($promotion = $db->fetch_array($query)){
			$promotion['promtitle'] = htmlspecialchars_uni($promotion['promtitle']);
			$promotion['promdesc'] = htmlspecialchars_uni($promotion['promdesc']);
			if($promotion['promforum']){
				$mn_fprom_count_forums = $mn_fprom_count_forum = $mn_fprom_split = '';
				$mn_fprom_in_forums = explode(',',$promotion['promforum']);
				foreach($mn_fprom_in_forums as $mn_fprom_in_forum){
					if($forum_cache[$mn_fprom_in_forum]['fid']){
						$mn_fprom_count_forum = htmlspecialchars_uni($forum_cache[$mn_fprom_in_forum]['name']);
					}else{
						$mn_fprom_count_forum = $lang->mn_fprom_forum_deleted;
					}
					$mn_fprom_count_forums .= $mn_fprom_split.$mn_fprom_count_forum;
					if(!$mn_fprom_split) $mn_fprom_split = ', ';
				}
			}
			switch($promotion['promreq']){
				case 1: $promotion['promreq'] = $lang->mn_fprom_post_count; break;
				case 2: $promotion['promreq'] = $lang->mn_fprom_thread_count; break;
			}
			$mn_fprom_criteria = $lang->sprintf($lang->mn_fprom_criteria,$promotion['promreq'],htmlspecialchars_uni($promotion['promcounttype']),my_number_format(intval($promotion['promcount'])),$mn_fprom_count_forums);
			if($groupscache[$promotion['promoug']]['gid']){
				$promotion['promoug'] = format_name(htmlspecialchars_uni($groupscache[$promotion['promoug']]['title']),$groupscache[$promotion['promoug']]['gid'],$groupscache[$promotion['promoug']]['gid']);
			}else{
				$promotion['promoug'] = $lang->mn_fprom_deleted_ug;
			}
			if($groupscache[$promotion['promnug']]['gid']){
				$promotion['promnug'] = format_name(htmlspecialchars_uni($groupscache[$promotion['promnug']]['title']),$groupscache[$promotion['promnug']]['gid'],$groupscache[$promotion['promnug']]['gid']);
			}else{
				$promotion['promnug'] = $lang->mn_fprom_deleted_ug;
			}
			switch ($promotion['promugtype']){
				case 1: $promotion['promugtype'] = $promotion['promoug'].': '.$lang->mn_fprom_pug.' '.$promotion['promnug']; break;
				case 2: $promotion['promugtype'] = $promotion['promoug'].': '.$lang->sprintf($lang->mn_fprom_add_sug,$promotion['promnug']); break;
				case 3: $promotion['promugtype'] = $promotion['promoug'].': '.$lang->sprintf($lang->mn_fprom_remove_sug,$promotion['promnug']); break;
			}
			if($promotion['promactive'] == 1){
				$promactive = '<img src="./styles/default/images/icons/bullet_on.gif" alt="'.$lang->mn_fprom_enabled_status.'" title="'.$lang->mn_fprom_enabled_status.'" class="float_right" />';
			}else{
				$promactive = '<img src="./styles/default/images/icons/bullet_off.gif" alt="'.$lang->mn_fprom_disabled_status.'" title="'.$lang->mn_fprom_disabled_status.'" class="float_right" />';
			}
			$table->construct_cell($form->generate_text_box('promdo['.$promotion['promid'].']',intval($promotion['promdo']),array('style'=>'width: 85%','class'=>'align_center')),array('class'=>'align_center'));
			$table->construct_cell('<div>'.$promactive.' <strong><a href="'.mn_fprom_url('edit',$promotion,'promid').'">'.$promotion['promtitle'].'</a></strong><br /><small>'.$promotion['promugtype'].'<br />'.$mn_fprom_criteria.'</small></div>',array('style'=>'width: 80%'));
			$popup = new PopupMenu('promotion_'.$promotion['promid'],$lang->options);
			$popup->add_item($lang->mn_fprom_edit,mn_fprom_url('edit',$promotion,'promid'));
			if($promotion['promactive'] == 1){
				$popup->add_item($lang->mn_fprom_disable_promotion,mn_fprom_url('disable',$promotion,'promid',1),"return AdminCP.deleteConfirmation(this, '{$lang->mn_fprom_confirm_promo_disable}')");
			}else{
				$popup->add_item($lang->mn_fprom_enable_promotion,mn_fprom_url('enable',$promotion,'promid',1));
			}
			$popup->add_item($lang->mn_fprom_delete_promotion,mn_fprom_url('delete',$promotion,'promid',1),"return AdminCP.deleteConfirmation(this, '{$lang->mn_fprom_confirm_promdel}')");
			$table->construct_cell($popup->fetch(),array('class'=>'align_center'));
			$table->construct_row();
		}
	}
	if($table->num_rows() == 0){
		$table->construct_cell($lang->mn_fprom_no_promotions_set);
		$table->construct_row();
		$no_data = true;
	}
	$table->output($lang->mn_fprom);
	if(!$no_data){
		$buttons[] = $form->generate_submit_button($lang->mn_fprom_update_promotion);
		$form->output_submit_wrapper($buttons);
	}
	$form->end();
	$page->output_footer();
}

if($mybb->input['action'] == 'update' && $mybb->request_method == 'post'){
	if(!is_array($mybb->input['promdo'])){
		admin_redirect(mn_fprom_url());
	}
	foreach($mybb->input['promdo'] as $promdo => $updates){
		if(intval($updates) < 1) $updates = 1;
		$db->update_query('mn_fprom',array('promdo'=>intval($updates)),'promid='.intval($promdo));
	}
	flash_message($lang->mn_fprom_success_promo_do_updated,'success');
	admin_redirect(mn_fprom_url());
}

function mn_fprom_url($act='',$ref='',$qr='',$pk=0){
	global $mybb;
	$action = '';
	if(!empty($act)) $action .= '&amp;action='.$act;
	if(!empty($qr)) $action .= '&amp;'.$qr.'='.intval($ref[$qr]);
	if(!empty($pk)) $action .= '&amp;my_post_key='.$mybb->post_code;
	return 'index.php?module=forum-mn_fprom'.$action;
}
?>