<?php
if(!defined('IN_MYBB')) die();

function mn_fprom_info(){
	return array(
		'name'			=> 'Forum Promotions',
		'description'	=> 'Promote users based on the num posts or threads in a specified forums.',
		'website'		=> 'http://mybbhacks.zingaburga.com',
		'author'		=> 'XThreads Mania',
		'authorsite'	=> 'http://mybbhacks.zingaburga.com',
		'version'		=> '1.0',
		'compatibility' => '16*',
		'guid'        	=> ''
	);
}

function mn_fprom_activate(){
	global $db, $cache;

	$db->write_query('CREATE TABLE '.TABLE_PREFIX.'mn_fprom (
		promid int(11) unsigned not null auto_increment,
		promtitle varchar(255) not null default \'\',
		promdo int(11) unsigned NOT NULL default 0,
		promreq tinyint(1) unsigned NOT NULL default 0,
		promcount int(11) unsigned NOT NULL default 0,
		promcounttype char(2) not null default \'\',
		promoug smallint(6) NOT NULL default 0,
		promnug smallint(6) NOT NULL default 0,
		promugtype tinyint(1) unsigned NOT NULL default 0,
		promforum text not null,
		promactive tinyint(1) unsigned NOT NULL default 0,
		PRIMARY KEY (promid), KEY(promactive), KEY(promdo)
	) ENGINE=MyISAM'.$db->build_create_table_collation());

	$db->write_query('CREATE TABLE '.TABLE_PREFIX.'mn_fprom_logs (
		promlid int(11) unsigned not null auto_increment,
		promid int(11) unsigned NOT NULL default 0,
		uid int(11) unsigned NOT NULL default 0,
		promoug varchar(255) not null default \'\',
		promnug smallint(6) NOT NULL default 0,
		promugtype tinyint(1) unsigned NOT NULL default 0,
		dateline bigint(30) unsigned NOT NULL default 0,
		PRIMARY KEY (promlid), KEY(uid), KEY(dateline)
	) ENGINE=MyISAM'.$db->build_create_table_collation());

	$db->insert_query('tasks',array(
		'title' => 'Forum Promotions',
		'description' => 'Promote users based on the number of their posts or threads in a specified forum.',
		'file' => 'mn_fprom',
		'minute' => '0',
		'hour' => '0',
		'day' => '*',
		'month' => '*',
		'weekday' => '*',
		'nextrun' => TIME_NOW + 86400,
		'lastrun' => 0,
		'enabled' => 1,
		'logging' => 1,
		'locked' => 0,
	));
	$cache->update_tasks();
}

function mn_fprom_deactivate(){
	global $db, $cache;
	if($db->table_exists('mn_fprom')) $db->drop_table('mn_fprom');
	if($db->table_exists('mn_fprom_logs')) $db->drop_table('mn_fprom_logs');
	$db->delete_query('tasks','file="mn_fprom"');
	$cache->update_tasks();
}

$plugins->add_hook('admin_forum_menu','mn_fprom_menu');
function mn_fprom_menu(&$sub_menu){
	global $lang;
	$lang->load('mn_fprom');
	$sub_menu[] = array('id'=>'mn_fprom','title'=>$lang->mn_fprom,'link'=>'index.php?module=forum-mn_fprom');
}

$plugins->add_hook('admin_forum_action_handler','mn_fprom_action');
function mn_fprom_action(&$actions){
	$actions['mn_fprom'] = array('active'=>'mn_fprom','file'=>'mn_fprom.php');
}
?>